/*
 * MuckConn.java
 *
 * Created on April 30, 2005, 9:32 PM
 */

/* JamochaMUD, a Muck/Mud client program
 * Copyright (C) 1998-2005  Jeff Robinson
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. *
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

package anecho.JamochaMUD;

/**
 *
 * @author  jeffnik
 */
public class MuckConn extends java.awt.Dialog {
    
    /** Creates new form MuckConn */
    // public MuckConn(java.awt.Frame parent, boolean modal) {
    public MuckConn(JMConfig settings) {
        super(settings.getJMFrame(JMConfig.MUCKMAINFRAME), true);
        // super(parent, modal);
        this.settings = settings;
        editName = settings.getJMVector(JMConfig.MUCKNAME);
        editAddy = settings.getJMVector(JMConfig.MUCKADDY);
        editPort = settings.getJMVector(JMConfig.MUCKPORT);

        initComponents();
       
        java.awt.Point tPoint = anecho.gui.PosTools.findCenter();
                // jmMCFrame.setLocation(tPoint.x - 237, tPoint.y - 185);
        java.awt.Dimension tSize= this.size();
        this.setLocation(tPoint.x - (int)(tSize.width/2) , tPoint.y - (int)(tSize.height/2));

        // jmStartUp();

    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jmMUNames = new java.awt.Choice();
        compileNames();
        topRowPanel = new java.awt.Panel();
        connButton = new java.awt.Button();
        addButton = new java.awt.Button();
        removeButton = new java.awt.Button();
        buttomRowPanel = new java.awt.Panel();
        editButton = new java.awt.Button();
        dontButton = new java.awt.Button();

        setLayout(new java.awt.GridBagLayout());

        setTitle(java.util.ResourceBundle.getBundle("anecho/JamochaMUD/JamochaMUDBundle").getString("JamochaMUDConnector"));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jmMUNames, gridBagConstraints);

        connButton.setLabel(java.util.ResourceBundle.getBundle("anecho/JamochaMUD/JamochaMUDBundle").getString("connect"));
        connButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                connButtonActionPerformed(evt);
            }
        });

        topRowPanel.add(connButton);

        addButton.setLabel(java.util.ResourceBundle.getBundle("anecho/JamochaMUD/JamochaMUDBundle").getString("addMU"));
        addButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addButtonActionPerformed(evt);
            }
        });

        topRowPanel.add(addButton);

        removeButton.setLabel(java.util.ResourceBundle.getBundle("anecho/JamochaMUD/JamochaMUDBundle").getString("removeMU"));
        removeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                removeButtonActionPerformed(evt);
            }
        });

        topRowPanel.add(removeButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(topRowPanel, gridBagConstraints);

        editButton.setLabel(java.util.ResourceBundle.getBundle("anecho/JamochaMUD/JamochaMUDBundle").getString("editMU"));
        editButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                editButtonActionPerformed(evt);
            }
        });

        buttomRowPanel.add(editButton);

        dontButton.setLabel(java.util.ResourceBundle.getBundle("anecho/JamochaMUD/JamochaMUDBundle").getString("dontConnect"));
        dontButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                dontButtonActionPerformed(evt);
            }
        });

        buttomRowPanel.add(dontButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.gridheight = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(buttomRowPanel, gridBagConstraints);

        pack();
    }//GEN-END:initComponents

    private void dontButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_dontButtonActionPerformed
        dontConnect();
    }//GEN-LAST:event_dontButtonActionPerformed

    private void addButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addButtonActionPerformed
        addMU();
    }//GEN-LAST:event_addButtonActionPerformed

    private void removeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeButtonActionPerformed
        removeMU();
    }//GEN-LAST:event_removeButtonActionPerformed

    private void editButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_editButtonActionPerformed
        editMU();
    }//GEN-LAST:event_editButtonActionPerformed

    private void connButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_connButtonActionPerformed
        connectToMU();
    }//GEN-LAST:event_connButtonActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
        
        // If the main window is not visible then we'll terminate the program.
        if (!(settings.getJMFrame(settings.MUCKMAINFRAME)).isVisible()) {
            System.exit(0);
        }
    }//GEN-LAST:event_closeDialog
    
    /**
     * Call the methods necessary for the user to add
     * a new MUD/MUCK to the list of worlds
     */
    private void addMU() {
        
        // int i = jmMUNames.getSelectedIndex();
        
        // Call the AddEdit box
        // AddEdit addMU = new AddEdit(jmMCFrame, RB("addMU"));
        AddEdit addMU = new AddEdit(settings.getJMFrame(JMConfig.MUCKMAINFRAME), java.util.ResourceBundle.getBundle("anecho/JamochaMUD/JamochaMUDBundle").getString("addMU"));
        // addMU.setSize(280, 160);
        // addMU.setLocation(PosTools.findCenter(jmMCFrame, addMU));
        addMU.setLocation(anecho.gui.PosTools.findCenter(this, addMU));
        addMU.setVisible(true);
        
        if (addMU.isOkay()) {
            String jmEditName = addMU.getName();
            String jmEditAddy = addMU.getAddress();
            String jmEditPort = addMU.getPort();
            
            jmEditName.trim();
            jmEditAddy.trim();
            jmEditPort.trim();
            
            if (!jmEditName.equals("") && !jmEditAddy.equals("") && !jmEditPort.equals("")) {
                // Check to see if the first entry is a 'valid'
                // MU*, or just a place-marker
                if ((settings.getJMVector(JMConfig.MUCKNAME)).size() < 1) {
                    // if (editName.elementAt(0).equals("None") & editAddy.elementAt(0).equals(blank)) {
                    jmMUNames.removeAll();
                }
                
                // Add the new entry to the list of available MU*s
                editName.addElement(jmEditName);
                editAddy.addElement(jmEditAddy);
                editPort.addElement(jmEditPort);
                jmMUNames.addItem(jmEditName + " (" + jmEditAddy + " Port: " + jmEditPort + ")");
                // Put new vector into the hashtable
                //settings.setMuckName(editName);
                //settings.setMuckAddy(editAddy);
                // settings.setMuckPort(editPort);
                settings.setJMValue(JMConfig.MUCKNAME, editName);
                settings.setJMValue(JMConfig.MUCKADDY, editAddy);
                settings.setJMValue(JMConfig.MUCKPORT, editPort);
                
                // Display new MU* in choice
                jmMUNames.select(jmMUNames.getItemCount() - 1);
                connButton.requestFocus();
                
            }
        }
        
    }
    
    /**
     * Remove the currently selected MUD/MUCK from the list
     * of available worlds (and the .jamocha.rc file).
     */
    private void removeMU() {
        // Remove MU* from list
        java.util.Vector muckName = new java.util.Vector(0, 1);
        java.util.Vector muckAddy = new java.util.Vector(0, 1);
        java.util.Vector muckPort = new java.util.Vector(0, 1);
        // muckName = settings.getMuckName();
        // muckAddy = settings.getMuckAddy();
        // muckPort = settings.getMuckPort();
        muckName = settings.getJMVector(JMConfig.MUCKNAME);
        muckAddy = settings.getJMVector(JMConfig.MUCKADDY);
        muckPort = settings.getJMVector(JMConfig.MUCKPORT);
        
        muckName.removeElementAt(jmMUNames.getSelectedIndex());
        muckAddy.removeElementAt(jmMUNames.getSelectedIndex());
        muckPort.removeElementAt(jmMUNames.getSelectedIndex());
        
        if (muckName.size() < 1) {
            jmMUNames.removeAll();
            muckName.addElement("None");
            muckAddy.addElement(blank);
            muckPort.addElement(blank);
            // jmMUNames.addItem("None" + " (" + blank + " Port: " + blank + ")");
            jmMUNames.addItem("None (" + blank + " Port: " + blank + ")");
        } else {
            jmMUNames.remove(jmMUNames.getSelectedIndex());
        }
        
        // Now place the vectors back in the Hashtable
        // settings.setMuckName(muckName);
        // settings.setMuckAddy(muckAddy);
        // settings.setMuckPort(muckPort);
        settings.setJMValue(JMConfig.MUCKNAME, muckName);
        settings.setJMValue(JMConfig.MUCKADDY, muckAddy);
        settings.setJMValue(JMConfig.MUCKPORT, muckPort);
    }
    
    /**
     * The user has opted to connect to the currently selected
     * MUD/MUCK, so we honour their wishes here!
     */
    private void connectToMU() {
        
        java.util.Vector tempAddy = new java.util.Vector(0, 1);
        java.util.Vector tempPort = new java.util.Vector(0, 1);
        
        tempAddy = settings.getJMVector(JMConfig.MUCKADDY);
        tempPort = settings.getJMVector(JMConfig.MUCKPORT);
        
        if (tempAddy.size() < 1) {
            // We don't have any valid MU*'s listed
            return;
        }
        
        if (DEBUG) {
            System.err.println("MuckConn.JMConnectToMU setVisible(false)");
        }
        
        // jmMCFrame.setVisible(false);
        // setVisible(false);
        //  System.out.println("MuckConn set jmMCFrame invisible");
        
        // MuckMain mainFrame = settings.getMainWindowVariable();
        java.awt.Frame mainFrame = settings.getJMFrame(JMConfig.MUCKMAINFRAME);
        
        if (!mainFrame.isVisible()) {
            mainFrame.setVisible(true);
            //  System.out.println("MuckConn set MuckMain set visible");
        }
        
        int selection = jmMUNames.getSelectedIndex();
        
        chosenName = editName.elementAt(selection).toString();
        finalAddress = tempAddy.elementAt(selection).toString();
        chosenPort = (Integer.parseInt(tempPort.elementAt(selection).toString()));
        
        //  System.out.println("Getting variables.");
        settings.setJMValue(JMConfig.CONNMUCK, finalAddress);
        settings.setJMValue(JMConfig.CONNPORT, chosenPort);
        settings.setJMValue(JMConfig.LASTMU, jmMUNames.getSelectedItem());
        
        /*
        if (DEBUG) {
            System.err.println("MuckConn.JMConnectToMU calling open Socket!?!?!?!");
        }
         
        MuSocket msock = connHandler.OpenSocket(chosenName, finalAddress, chosenPort);
        if (DEBUG) {
            System.err.println("MuckConn.JMConnectToMU adding MU to display");
        }
        connHandler.addNewMU(chosenName, finalAddress, chosenPort, msock);
        if (DEBUG) {
            System.err.println("MuckConn.JMConnectToMU new MU* added.");
            }
         */
        // connHandler.setVisibleMU();
        
        /*
        mainFrame.addNewMU(msock);
        mainFrame.setVisibleMU();
         */
        setVisible(false);
        
        // We only want to set the Main Layout once
        if (!settings.getJMboolean(JMConfig.MAINLAYOUTVALID)) {
            //  System.out.println("MuckConn calling tempMain.setMainLayout()");
            // mainFrame.setMainLayout();
            (settings.getMainWindowVariable()).setMainLayout();
        }
        
        settings.setJMValue(JMConfig.MUCKCONNVISIBLE, false);
        // mainWindow.setVisibleMU();  // XXX removed for trouble-shooting
        
        // settings.getMainWindowVariable().setMainLayout();
        
        // System.out.println("MuckConn.JMConnectToMU requesting focus of main window.");
        // Send the focus to out main program... just a nice thing to do
        // settings.getMainWindowVariable().requestFocus();
        //  System.out.println("MuckConn calling tempMain.requestFocus()");
        if (DEBUG) {
            System.err.println("MuckConn.JMConnectToMU returning focus to main frame.");
        }
        mainFrame.requestFocus();
        // settings.getMainWindowVariable().setVisibleMU();
        // System.out.println("MuckConn.JMConnectToMU focused.");
        
    }
    
    /**
     * Call the methods to allow the user to edit the MUD/MUCK
     * Name/address/port of the currently selected world
     */
    private void editMU() {
        // edit current MU* entry
        // AddEdit editBox = new AddEdit(jmMCFrame, RB("editMU"));
        AddEdit editBox = new AddEdit(settings.getJMFrame(JMConfig.MUCKMAINFRAME), java.util.ResourceBundle.getBundle("anecho/JamochaMUD/JamochaMUDBundle").getString("editMU"));
        
        int index = jmMUNames.getSelectedIndex();
        editBox.setName((String)editName.elementAt(index));
        editBox.setAddress((String)editAddy.elementAt(index));
        editBox.setPort((String)editPort.elementAt(index));
        // editBox.setSize(280, 160);
        // editBox.setLocation(PosTools.findCenter(jmMCFrame, editBox));
        editBox.setLocation(anecho.gui.PosTools.findCenter(this, editBox));
        editBox.setVisible(true);
        
        // Call the AddEdit box
        
        if (editBox.isOkay()) {
            String jmEditName = editBox.getName();
            String jmEditAddy = editBox.getAddress();
            String jmEditPort = editBox.getPort();
            
            jmEditName.trim();
            jmEditAddy.trim();
            jmEditPort.trim();
            
            if (!jmEditName.equals("") && !jmEditAddy.equals("") && !jmEditPort.equals("")) {
                // Replace the edited MU* info
                editName.removeElementAt(index);
                editAddy.removeElementAt(index);
                editPort.removeElementAt(index);
                
                editName.insertElementAt(jmEditName, index);
                editAddy.insertElementAt(jmEditAddy, index);
                editPort.insertElementAt(jmEditPort, index);
                
                // Put new vector into the hashtable
                // settings.setMuckName(editName);
                // settings.setMuckAddy(editAddy);
                // settings.setMuckPort(editPort);
                settings.setJMValue(JMConfig.MUCKNAME, editName);
                settings.setJMValue(JMConfig.MUCKADDY, editAddy);
                settings.setJMValue(JMConfig.MUCKPORT, editPort);
                
                // Replace the choice entry
                jmMUNames.remove(index);
                jmMUNames.insert(jmEditName + " (" + jmEditAddy + " Port: " + jmEditPort + ")", index);
                jmMUNames.select(index);
                connButton.requestFocus();
                
            }
        }
    }
    
    /** Initialise all the starting windows and such
     *
     */
    private void jmStartUp() {
        
        // Read in the environmental variables
        /*
        MediaTracker tracker = new MediaTracker(jmMCFrame);
        Class testC = this.getClass();
        jamochaMUDImage = Toolkit.getDefaultToolkit().getImage(testC.getResource("kehza.gif"));
         
        // jamochaMUDImage = Toolkit.getDefaultToolkit().getImage("kehza.gif");
        tracker.addImage(jamochaMUDImage, 0, 16, 16);
        try {
            tracker.waitForAll();
        } catch (Exception e) {
            System.out.println("Icon load error.  Exception " + e);
        }
         
        settings.setIconImage(jamochaMUDImage);
         
        jmMCFrame.setIconImage(jamochaMUDImage);
         */
        
        // set up the Muck Name variables
        compileNames();
        
    }
    
    /**
     * Compile the MU* names
     * and then write them into the
     * choice of jmMCFrame
     */
    private void compileNames() {
        // First grab the vectors
        java.util.Vector muckAddy = new java.util.Vector(0, 1);
        java.util.Vector muckName = new java.util.Vector(0, 1);
        java.util.Vector muckPort = new java.util.Vector(0, 1);
        
        // muckName = settings.getMuckName();
        // muckAddy = settings.getMuckAddy();
        // muckPort = settings.getMuckPort();
        muckName = settings.getJMVector(JMConfig.MUCKNAME);
        muckAddy = settings.getJMVector(JMConfig.MUCKADDY);
        muckPort = settings.getJMVector(JMConfig.MUCKPORT);
        
        /* We have no listed MU*'s, so we'll put in a default */
        if (muckName.size() < 1) {
            muckName.addElement("None");
            muckAddy.addElement(blank);
            muckPort.addElement(blank);
        }
        
        for (int i=0; i < muckName.size(); i++) {
            jmMUNames.addItem(muckName.elementAt(i) + " (" + muckAddy.elementAt(i) + " Port: " + muckPort.elementAt(i) + ")");
        }
        
        
        // Set the 'focus' on the last-selected MU*
        // if (settings.getLastMU() != null) {
        if (settings.getJMString(JMConfig.LASTMU) != null) {
            // try {
            // jmMUNames.select(settings.getLastMU());
            jmMUNames.select(settings.getJMString(JMConfig.LASTMU));
            // } catch (Exception e) {
            // There may not have been a previous selection
        }
        
    }
    
    public String getName() {
        return chosenName;
    }
    
    public String getAddress() {
        return finalAddress;
    }
    
    public int getPort() {
        return chosenPort;
    }
    
    private void dontConnect() {
                // jmMCFrame.setVisible(false);
            setVisible(false);

            // MuckMain mm = settings.getMainWindowVariable();
            java.awt.Frame mmFrame = settings.getJMFrame(JMConfig.MUCKMAINFRAME);
            if (!mmFrame.isVisible()) {
                mmFrame.setVisible(true);
            }

            settings.setJMValue(JMConfig.MUCKCONNVISIBLE, false);

            // Send the focus to out main program... just a nice thing to do
            // settings.getMainWindowVariable().requestFocus();
            mmFrame.requestFocus();
    
    }
    
    /** Closes the dialog */
    /*
    private void closeDialog(java.awt.event.WindowEvent evt) {
        // Fix ME XXX - For right now we're just going to ignore this event
        setVisible(false);
        dispose();
        
        // If the main window is not visible then we'll terminate the program.
        if (!(settings.getJMFrame(settings.MUCKMAINFRAME)).isVisible()) {
            System.exit(0);
        }
    }
    */
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private java.awt.Button addButton;
    private java.awt.Panel buttomRowPanel;
    private java.awt.Button connButton;
    private java.awt.Button dontButton;
    private java.awt.Button editButton;
    private java.awt.Choice jmMUNames;
    private java.awt.Button removeButton;
    private java.awt.Panel topRowPanel;
    // End of variables declaration//GEN-END:variables
    private java.util.Vector editName = new java.util.Vector(0, 1);
    private java.util.Vector editAddy = new java.util.Vector(0, 1);
    private java.util.Vector editPort = new java.util.Vector(0, 1);
    private JMConfig settings;
    private static final boolean DEBUG = false;
        private String chosenName = null;
    private String finalAddress = null;
    private int chosenPort;
    private String blank = "----";
}
